/* Amir Israeli  Email : israelaq@walla.co.il */
/* Written by Amir Israeli  July 2000  
dont remove this header , thanks , Amir
*/
// ComboRegistryHistory.cpp : implementation file
//

#include "stdafx.h"
#include "Resource.h"
#include "ComboRegistryHistory.h"
#include "Registry.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CComboRegistryHistory

#define DEFAULT_COMBOBOX_STYLE  CBS_DROPDOWN|CBS_AUTOHSCROLL|CBS_NOINTEGRALHEIGHT
#define MAX_ITEMS_IN_COMBO 25

CComboRegistryHistory::CComboRegistryHistory()
{
	m_RegistryPath = _T("HKEY_CURRENT_USER\\Software\\Amir Israeli\\Browse2Reg\\1.0\\Paths");
}
CComboRegistryHistory::~CComboRegistryHistory()
{
}

BEGIN_MESSAGE_MAP(CComboRegistryHistory, CComboBox)
	//{{AFX_MSG_MAP(CComboRegistryHistory)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_CONTROL_REFLECT(CBN_SELCHANGE, OnSelchange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComboRegistryHistory message handlers
BOOL CComboRegistryHistory::SubclassDlgItem(UINT nID, CWnd* pParent)
{
	if (CComboBox::SubclassDlgItem(nID , pParent)) {
		Install();
		Load();
		return TRUE;
	}
	return FALSE;
}

BOOL CComboRegistryHistory::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style = DEFAULT_COMBOBOX_STYLE;
	return CComboBox::PreCreateWindow(cs);
}
void CComboRegistryHistory::PreSubclassWindow() 
{
	ModifyStyle( 0, DEFAULT_COMBOBOX_STYLE, 0);	
	CComboBox::PreSubclassWindow();
}
int CComboRegistryHistory::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CComboBox::OnCreate(lpCreateStruct) == -1)
		return -1;
	Install();
	Load();
	return 0;
}
void CComboRegistryHistory::OnDestroy() 
{
	Save();
	DeleteAll();
	CComboBox::OnDestroy();
}
BOOL CComboRegistryHistory::AddPath(LPCTSTR lpszPath)
{
	if (!lpszPath)  return FALSE;
	DeletePath(lpszPath);

	while (GetCount() > MAX_ITEMS_IN_COMBO)
		DeleteString((UINT)0);

	AddString(lpszPath);
	return TRUE;
}
BOOL CComboRegistryHistory::DeletePath(LPCTSTR lpszPath)
{
	if (!lpszPath)  return FALSE;
	int iFind = FindString( -1, lpszPath);
	if (iFind == CB_ERR)
		return TRUE;
	if (iFind>=0)
		DeleteString( (UINT)iFind);
	return TRUE;
}
void CComboRegistryHistory::DeleteAll()
{
	ResetContent();
}

BOOL CComboRegistryHistory::Install()
{
	CRegistry  reg;	
	CString path = m_RegistryPath;
	if (reg.IsExistKey( path))
		return TRUE;
	if (!reg.CreateKey( path))
			return FALSE;
	CString strValue , strData = _T("");
	for (int i=0 ; i<MAX_ITEMS_IN_COMBO ; i++) {
		strValue.Format("value [%d]",i+1);
		reg.CreateValueString( m_RegistryPath, strValue, &strData);
	}// end for loop
	return TRUE;
}
BOOL CComboRegistryHistory::UnInstall()
{
	CRegistry reg;
	if (!reg.IsExistKey(m_RegistryPath))
		return reg.DeleteKey( m_RegistryPath);
	return TRUE;
}
BOOL CComboRegistryHistory::Save()
{
	CRegistry reg;
	for (int i=0 , iCount = GetCount() ; i<MAX_ITEMS_IN_COMBO ; i++ ) {
		CString strValue, strData;
		strValue.Format("value [%d]",i+1);
		if (i<iCount)
			GetLBText( i, strData);
		else  strData = _T("");
		reg.SetValueString( m_RegistryPath, strValue, strData);
	}
	return TRUE;
}
BOOL CComboRegistryHistory::Load()
{
	CString strKey = m_RegistryPath;
	CRegistry reg;
	for (int i=0 ; i<MAX_ITEMS_IN_COMBO ; i++ ) {
		CString value;
		value.Format("value [%d]",i+1);
		CString strData;
		if ((reg.GetValueString( m_RegistryPath, value, &strData)) && (!strData.IsEmpty())) {
			if (!strData.IsEmpty())
				AddPath(strData);
		}
	}
	return TRUE;
}

BOOL CComboRegistryHistory::SetPath(LPCTSTR lpszPath)
{
	return AddPath(lpszPath);
}
CString CComboRegistryHistory::GetPath()
{
	CString  strText;
	GetWindowText(strText);
	return strText;
}
void CComboRegistryHistory::OnSelchange() 
{
	int iSelected = GetCurSel();
	if (iSelected != CB_ERR) {
		CString strPath;
		GetLBText( iSelected, strPath);
		GetParent()->SendMessage(WM_UPDATEPATHFROMCOMBO,(WPARAM)(LPCTSTR)strPath);
		SetCurSel( iSelected);
	}
}

BOOL CComboRegistryHistory::PreTranslateMessage(MSG* pMsg) 
{
	if (::GetKeyState(VK_RETURN)<0) {
		CString strPath = GetPath();
		GetParent()->SendMessage(WM_UPDATEPATHFROMCOMBO,(WPARAM)(LPCTSTR)strPath);
	}
	return CComboBox::PreTranslateMessage(pMsg);
}
