/* Amir Israeli  Email : israelaq@walla.co.il */
/* Written by Amir Israeli  July 2000  
dont remove this header , thanks , Amir
*/
/*  This file was written by Amir Israeli , July 2000   Email: israelaq@walla.co.il  
No warranty of any kind . Dont remove this header . Thanks.
*/
// Registry.h: interface for the CRegistry class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGISTRY_H__D396E6E2_5043_11D4_B8C4_9BEAE49E475A__INCLUDED_)
#define AFX_REGISTRY_H__D396E6E2_5043_11D4_B8C4_9BEAE49E475A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Message.h"

class CRegistryBase  
{
public:
	CRegistryBase();
	virtual ~CRegistryBase();

	//Trims a character off a string (both sides)
	void Trim(CString *strRegPath,TCHAR ch=_T('\\'));
	BOOL AppendPath(CString *strRegTarget,LPCTSTR strRegSrc);
	
	/////// Level functions
	int CountLevels( LPCTSTR lpszRegPath);
	BOOL GetLevel(int iLevel, LPCTSTR lpszRegPath,CString *strRegOut);
	BOOL GetLastLevel( LPCTSTR lpszRegPath, CString *strRegOut);
	BOOL LevelInPath( LPCTSTR lpszRegPath, CString *strWantedKey);
	BOOL GetLevelBeforeLevel( LPCTSTR lpszRegPath , LPCTSTR lpszBeforeLevel,CString *strOut,BOOL bGiveRoot=FALSE);
	BOOL GetLevelAfterLevel( LPCTSTR lpszRegPath, LPCTSTR lpszAfterLevel,CString *strOut);
	BOOL RemoveLastItem(CString *strRegPath);

	//extracts the root keys from path and resets the string 
	//to the rest of the sub string (sub key) 
	BOOL  FormulatePath(CString *strRegPath,HKEY *hKey);
	void msg( LPCTSTR lpszText = NULL , LPCTSTR lpszTitle = NULL);

	/// Enumeration functions
	int Enum( HKEY hKey,CString *strRegPath,CStringArray *strKeyNames,CStringArray *strClassNames=NULL,BOOL bFullPath=FALSE);
	int Enum( CString *strRegPath,CStringArray *strKeyNames,CStringArray *strClassNames=NULL,BOOL bFullPath=FALSE);
	int Enum1Level( CString *strRegPath,CStringArray *strKeyNames,BOOL bFullPath=FALSE);

////////////////////////////////////////////////////////
///////// Open Keys functions
	BOOL Open(CString *strPath,HKEY *pNewKey,REGSAM samDesired=KEY_READ);
	BOOL Open(HKEY hKey,CString *strPath,HKEY *pNewKey,REGSAM samDesired=KEY_READ);
	BOOL Close(HKEY hKey);
	BOOL Close(HKEY *hKey);
	//// Flush function : immediate write
	BOOL Flush(HKEY hKey);

public:  ///////  IsRoot functions
	BOOL IsRoot(CString *strRegPath);
	BOOL IsRoot(LPCTSTR lpszRegPath);
	BOOL IsRoot(HKEY *hKey,CString *strRegPath=NULL);
	BOOL IsRoot(HKEY hKey,CString strRegPath=_T(""));

public:
	BOOL IsExistValue(LPCTSTR lpszKeyName,LPCTSTR lpszValue);
	BOOL IsExistValue(LPCTSTR lpszKeyName,CStringArray *arr, CWordArray *bArrFound);
protected:
	BOOL IsExistValue(HKEY *hKey , LPCTSTR lpszValue);
	BOOL IsExistValue(HKEY *hKey , CStringArray *arr , CWordArray *bArrFound);

public:
	BOOL IsKeyHasSubKeys(LPCTSTR lpszRegPath);
	int  GetSubKeyCount(LPCTSTR lpszRegPath);
protected:
	BOOL IsKeyHasSubKeys(HKEY hRegKey);
	int  GetSubKeyCount(HKEY hKey);

public:
	//Sets flush status and returns the previous status  
	BOOL GetFlush(){ return bAutoFlush; }
	BOOL SetFlush(BOOL bFlush = FALSE);

protected:
	CString Rootkey2String(HKEY *hKey);
	BOOL Rootkey2String(CString *strRegSrc,HKEY *hKey);
	BOOL StringRoot2key(LPCTSTR lpszRegPath,HKEY *hKey);
private:
	BOOL bAutoFlush; // determines whether to flush keys
	// whenever we save it (unrecommended:takes many resources)
};


///// This class provides standard support for the registry
// with some wrappers for many functions
class CRegistry : public CRegistryBase  
{
public:
	CRegistry();
	virtual ~CRegistry();

	/////// IsExistKey functions
	BOOL IsExistKey(LPCTSTR lpszRegPath);
	BOOL IsExistKey(const CString &strWantedKey,const CString &strRegPath,int iLevelRequired=-1);
	BOOL IsExistKey(CString *strWantedKey,CString *strRegPath,int iLevelRequired=-1);
	BOOL IsExistKey(const CString &strWantedKey,CStringArray *strKeyNames,int iLevelRequired=-1);
	BOOL IsExistKey(CString *strWantedKey,CStringArray *strKeyNames,int iLevelRequired=-1);

	////////////////////////////////////////////////////////
	//////////////
	//gets a pointer 
	//NOTICE !!!  The caller MUST DELETE the allocated MEMORY !!!
	BOOL GetValue( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,LPBYTE *pBuffer,DWORD *pdwType,DWORD *pdwDataGot);
	
	//High level functions
	BOOL GetValueDefault( LPCTSTR lpszRegPath, CString *strResult);
	BOOL GetValueString( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,CString *strResult);
	
	//no need to delete
	BOOL GetValueSized( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,LPVOID pData,size_t size);

	BOOL GetValueInt( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,int *iResult);
	BOOL GetValueUInt( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,UINT *uResult);
	BOOL GetValueFloat( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,float *fResult);

///////////////////////////////////////////////////////////
/////////// Functions to Delete Keys and Values ....
public:
	BOOL DeleteKey(LPCTSTR lpszRegPath);
	BOOL DeleteValue( LPCTSTR lpszRegPath, LPCTSTR lpszValueName);
protected:
	BOOL DeleteKey(HKEY *hKey,LPCTSTR lpszRegPath);
	BOOL DeleteValue(HKEY *hKey, LPCTSTR lpszValueName);

public: //Function to set values
	BOOL SetValueInt( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,int iData = 0);
	BOOL SetValueFloat( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,float fData = 0.0);
	BOOL SetValueString( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,LPCTSTR lpszData = NULL );
	BOOL SetValueUint( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,DWORD dwData=0);
	BOOL SetValue( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,LPVOID pData ,size_t size = 0,DWORD dwType=REG_BINARY);
protected:
	BOOL SetValue(HKEY *hKey,LPCTSTR lpszValueName,LPVOID pData ,size_t size = 0,DWORD dwType=REG_BINARY);

////////////////////////////////////////////////////////////
////// Functions to create Keys and Values
public:
	BOOL CreateKey( LPCTSTR lpszRegPath);
	BOOL CreateKey( LPCTSTR lpszRegPath, LPCTSTR lpszRegNewKey);

	BOOL CreateValueString( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,CString *strData);
	BOOL CreateValueDword( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,DWORD dwData);
	BOOL CreateValueInt( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,int iData);
	BOOL CreateValueFloat( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,float fData);
	BOOL CreateValue( LPCTSTR lpszRegPath, LPCTSTR lpszValueName,
				LPBYTE pData,DWORD cbSize=0,DWORD dwType=REG_BINARY);
protected:
	BOOL CreateKey( HKEY *hKey, LPCTSTR lpszRegPath);

	BOOL CreateValueString(HKEY *hKey,LPCTSTR lpszValueName,CString *strData);
	BOOL CreateValueInt(HKEY *hKey,LPCTSTR lpszValueName,int iData);
	BOOL CreateValueDword(HKEY *hKey,LPCTSTR lpszValueName,DWORD dwData);
	BOOL CreateValueFloat(HKEY *hKey,LPCTSTR lpszValueName,float fData);
	
	BOOL CreateValue(HKEY *hKey,LPCTSTR lpszValueName,
				LPBYTE pData,DWORD cbSize=0,DWORD dwType=REG_BINARY);

};


#endif // !defined(AFX_REGISTRY_H__D396E6E2_5043_11D4_B8C4_9BEAE49E475A__INCLUDED_)
