/* Amir Israeli  Email : israelaq@walla.co.il */
/* Written by Amir Israeli  July 2000  
dont remove this header , thanks , Amir
*/
// RegistryExplorerServices.cpp: implementation of the CRegistryExplorerServices class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RegistryExplorerServices.h"
#include "Registry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
enum { REGDIR = 0 ,REGDIROPEN = 1, REGFILE = 2 ,REGFILEOPEN = 3}; 

CRegistryExplorerServices::CRegistryExplorerServices()
{
}
CRegistryExplorerServices::~CRegistryExplorerServices()
{
}

BOOL CRegistryExplorerServices::SubClassDlgItem( CTreeCtrl &tree ,UINT nID ,CWnd* pParentWnd, LPCTSTR lpszRegPath )
{
	if (tree.SubclassDlgItem( nID , pParentWnd)) {
		InitRootItems(tree);
		if (lpszRegPath)  SetPath( tree , lpszRegPath);
		return TRUE;
	}
	return FALSE;
}

BOOL CRegistryExplorerServices::SetImageList( CTreeCtrl &tree, CImageList *pImageList, UINT nImageID, int cx)
{
	if (pImageList->GetSafeHandle())
		 pImageList->DeleteImageList();
	
	if (pImageList->Create( nImageID, cx, 1, RGB(255,0,255))) {
		tree.SetImageList( pImageList,TVSIL_NORMAL);
		return TRUE;
	}
	return FALSE;
}

DWORD CRegistryExplorerServices::GetDefaultTreeStyle()
{
	DWORD dwStyle = TVS_SHOWSELALWAYS|WS_CHILD|TVS_LINESATROOT|
		TVS_HASBUTTONS|WS_VISIBLE|TVS_HASLINES|WS_VISIBLE;
	return dwStyle;
}
DWORD CRegistryExplorerServices::GetDefaultListStyle()
{
	DWORD dwStyle = LVS_ALIGNTOP|LVS_ICON|LVS_AUTOARRANGE|
		LVS_SHAREIMAGELISTS|WS_VISIBLE|WS_CHILD;
	return dwStyle;
}
DWORD CRegistryExplorerServices::GetDefaultTreeExStyle()
{
	DWORD dwStyle = 0;
	return dwStyle;
}
DWORD CRegistryExplorerServices::GetDefaultListExStyle()
{
	DWORD dwStyle = 0;
	return dwStyle;
}

BOOL CRegistryExplorerServices::IsExpanded( CTreeCtrl &tree, HTREEITEM hItem)
{
	UINT uState = tree.GetItemState( hItem, TVIF_STATE);
	return (uState & TVIS_EXPANDED);
}

HTREEITEM CRegistryExplorerServices::FindChild( CTreeCtrl &tree, LPCTSTR lpszName ,HTREEITEM hParent)
{
	if (!hParent)  return NULL;
	HTREEITEM hItem = tree.GetChildItem(hParent);
	while (hItem) {
		CString text = tree.GetItemText(hItem);
		if (!text.CompareNoCase(lpszName)) {
			tree.Expand( hItem, TVE_COLLAPSE);   
			DeleteAllChildren( tree, hItem);
			Enum( tree, hItem);
			tree.Expand( hItem, TVE_EXPAND);
			tree.SelectItem( hItem);
			return hItem;
		}
		hItem = tree.GetNextSiblingItem(hItem);
	}
	return NULL;
}


BOOL CRegistryExplorerServices::SetPath( CTreeCtrl &tree, LPCTSTR lpszRegPath )
{
	if (!lpszRegPath)  return FALSE;
	CWaitCursor  wait;

	CString strNewPath = lpszRegPath;
	CRegistry reg;
	reg.Trim(&strNewPath);
	HTREEITEM hItem = TVI_ROOT;
	int iLevelCount = reg.CountLevels( strNewPath);
	for (int i=0 ; i<iLevelCount ; i++) {
		CString tmp;
		if (reg.GetLevel( i, strNewPath, &tmp)) {
			if (hItem)
				hItem = FindChild( tree, tmp, hItem);
		}
	} //now hItem includes the path

	hItem = tree.GetSelectedItem();
	strNewPath = PathFromItem( tree, hItem);

	return TRUE;
}

void CRegistryExplorerServices::OnItemexpanding( CTreeCtrl &tree, NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM  hItem = pNMTreeView->itemNew.hItem;
	CWaitCursor wait;

    if (pNMTreeView->action==TVE_EXPAND)
	{
		DeleteAllChildren( tree, hItem);
		Enum( tree, hItem);
    }
	else // pNMTreeView->action==TVE_COLLAPSE
	{
		DeleteAllChildren( tree, hItem);
		AddDummy(tree ,hItem);
	}//end collapsing
	
	*pResult = 0;
}
void CRegistryExplorerServices::OnSelchanging( CTreeCtrl &tree, NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM  hItem = pNMTreeView->itemNew.hItem;
	CString strTotalPath = PathFromItem( tree, hItem);
	*pResult = 0;
}

void CRegistryExplorerServices::OnSelchanged( CTreeCtrl &tree, NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM  hItem = pNMTreeView->itemNew.hItem;
	//updating parent
	CWnd *pWnd = tree.GetParent();
	if (pWnd) {
		CString strPath = GetPath(tree);
		pWnd->SendMessage(WM_UPDATEPATHFROMTREE,(WPARAM)(LPCTSTR)strPath);
	}
	*pResult = 0;
}

void CRegistryExplorerServices::OnDestroy( CTreeCtrl &tree) 
{
	tree.DeleteAllItems();
}

BOOL CRegistryExplorerServices::Enum( CTreeCtrl &tree, HTREEITEM hParent)
{
	CStringArray arr;
	arr.SetSize(0,1);
	CRegistry reg;
	CString strTotalPath = PathFromItem( tree, hParent);
	reg.Enum1Level( &strTotalPath, &arr);
	for ( int i=0, iCount = arr.GetSize() ; i<iCount ; i++) {
		CString tmp = arr.GetAt(i);
		AddItem( tree, hParent , (LPCTSTR) tmp);
	}
	return TRUE;
}


BOOL CRegistryExplorerServices::AddDummy( CTreeCtrl &tree, HTREEITEM hParent)
{
	return (tree.InsertItem( _T("Dummy"), REGDIR, REGDIROPEN , hParent, TVI_SORT) != NULL);
}
BOOL CRegistryExplorerServices::AddItem( CTreeCtrl &tree, HTREEITEM hParent ,LPCTSTR lpszItem)
{
	int nImage = REGDIR, nSelectedImage = REGDIROPEN;
	if (hParent != TVI_ROOT) {
		CString strTotalPath = GetPath( tree ,hParent, lpszItem);
		CRegistry reg;
		if (!reg.IsKeyHasSubKeys( strTotalPath)) {
			nImage = REGFILE ;
			nSelectedImage = REGFILEOPEN ;
		}
	}
	HTREEITEM hNewItem = tree.InsertItem(lpszItem , nImage, nSelectedImage , hParent, TVI_SORT);
	if ((hNewItem) && (nImage == REGDIR)) {
		AddDummy( tree, hNewItem);
	}
	return (hNewItem) ? TRUE : FALSE;
}

BOOL CRegistryExplorerServices::InitRootItems( CTreeCtrl &tree)
{
	AddItem( tree , TVI_ROOT , _T("HKEY_CLASSES_ROOT"));
	AddItem( tree , TVI_ROOT , _T("HKEY_CURRENT_CONFIG"));
	AddItem( tree , TVI_ROOT , _T("HKEY_CURRENT_USER"));
	AddItem( tree , TVI_ROOT , _T("HKEY_LOCAL_MACHINE"));
	AddItem( tree , TVI_ROOT , _T("HKEY_USERS"));
#ifdef UNICODE 
	AddItem( tree , TVI_ROOT , _T("HKEY_PERFORMANCE_DATA"));
#else 
	AddItem( tree , TVI_ROOT , _T("HKEY_DYN_DATA"));
#endif
	return ( tree.GetChildItem(TVI_ROOT)!=NULL);
}

BOOL CRegistryExplorerServices::DeleteAllChildren( CTreeCtrl &tree, HTREEITEM hParent)
{
	if (!hParent) return FALSE;
	HTREEITEM hPrevItem ,hChildItem = tree.GetChildItem(hParent) ;

	CWaitCursor wait;
	while (hChildItem) {
		DeleteAllChildren( tree, hChildItem);//recursive
		hPrevItem = hChildItem;
		hChildItem = tree.GetNextSiblingItem(hChildItem);
		tree.DeleteItem(hPrevItem);
	}
	return TRUE;
}

BOOL CRegistryExplorerServices::GoUp( CTreeCtrl &tree, HTREEITEM hItem)
{
	if (!hItem)	hItem = tree.GetSelectedItem();
	if (!hItem) return FALSE;
	hItem = tree.GetParentItem(hItem);
	if (!hItem) return FALSE;
	tree.SelectItem(hItem);
	return TRUE;
}
BOOL CRegistryExplorerServices::ExpandItem( CTreeCtrl &tree, HTREEITEM hItem)
{
	if (!hItem)
		hItem = tree.GetSelectedItem();
	if (!hItem) return FALSE;
	if (IsExpanded( tree, hItem))
		return TRUE;

	DeleteAllChildren( tree, hItem);
	Enum( tree, hItem);
 	tree.Expand( hItem, TVE_EXPAND);
	return TRUE;
}

BOOL CRegistryExplorerServices::CollapseItem( CTreeCtrl &tree, HTREEITEM hItem)
{
	if (!hItem)
		hItem = tree.GetSelectedItem();
	if (!hItem) return FALSE;
	if (!IsExpanded( tree, hItem))
		return TRUE;

	DeleteAllChildren( tree, hItem);
	AddDummy(tree ,hItem);
	tree.Expand( hItem, TVE_COLLAPSE);
	return TRUE;
}

BOOL CRegistryExplorerServices::OnKeyDown( CTreeCtrl &tree, UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CWaitCursor  wait;
	switch (nChar)
	{
	case VK_UP:	//is Ctrl key pressed ?
				if (::GetAsyncKeyState(VK_CONTROL)<0)
					return GoUp(tree);
				break;	
	case VK_LEFT: return CollapseItem(tree);
	case VK_RIGHT: return ExpandItem(tree);
	//case :
	}
	return FALSE;
}

CString CRegistryExplorerServices::PathFromItem( CTreeCtrl &tree, HTREEITEM hItem)
{
	HTREEITEM hParent = tree.GetParentItem(hItem);
	if (!hParent) {
		CString text = tree.GetItemText(hItem);
		return text;
	}
	else {
		CString strTotalPath = PathFromItem( tree, hParent);
		CString strText = tree.GetItemText(hItem);
		CRegistry reg;
		reg.AppendPath( &strTotalPath, strText);
		return strTotalPath;
	}
	return _T("");
}
CString CRegistryExplorerServices::GetPath( CTreeCtrl &tree, HTREEITEM hItem ,LPCTSTR lpszItem)
{
	CString strFullPath = PathFromItem( tree, hItem);
	CRegistry reg;
	reg.AppendPath( &strFullPath,lpszItem);
	return strFullPath;
}

CString CRegistryExplorerServices::GetPath( CTreeCtrl &tree)
{
	HTREEITEM  hItem = tree.GetSelectedItem();
	if (!hItem)  return _T("");
	CString strFullPath = PathFromItem( tree, hItem);
	return strFullPath;
}




