/* Amir Israeli  Email : israelaq@walla.co.il */
/* Written by Amir Israeli  July 2000  
dont remove this header , thanks , Amir
*/
// TRegistryExplorerView.cpp : implementation of the CTRegistryExplorerView class
//

#include "stdafx.h"
#include "Resource.h"
#include "TRegistryExplorerView.h"
#include "Registry.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTRegistryExplorerView

/////////////////////////////////////////////////////////////////////////////
// CTRegistryExplorerView construction/destruction

CTRegistryExplorerView::CTRegistryExplorerView()
{
}
CTRegistryExplorerView::~CTRegistryExplorerView()
{
}

IMPLEMENT_DYNCREATE(CTRegistryExplorerView, CTreeView)

BEGIN_MESSAGE_MAP(CTRegistryExplorerView, CTreeView)
	//{{AFX_MSG_MAP(CTRegistryExplorerView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemexpanding)
	ON_NOTIFY_REFLECT(TVN_SELCHANGING, OnSelchanging)
	ON_WM_KEYDOWN()
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CTRegistryExplorerView::PreSubclassWindow() 
{
	DWORD dwStyle = services.GetDefaultTreeStyle();
	ModifyStyle( 0, dwStyle , 0);
	CTreeView::PreSubclassWindow();
}
BOOL CTRegistryExplorerView::PreCreateWindow(CREATESTRUCT& cs)
{
	DWORD dwStyle = services.GetDefaultTreeStyle();
	cs.style = (long) dwStyle;

	return CTreeView::PreCreateWindow(cs);
}

int CTRegistryExplorerView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CTreeView::OnCreate(lpCreateStruct) == -1)
		return -1;
	services.SetImageList( GetTreeCtrl(), &il, IDB_SMALLICONS, 16);
	services.InitRootItems( GetTreeCtrl());

	return 0;
}
void CTRegistryExplorerView::OnDestroy() 
{
	GetTreeCtrl().DeleteAllItems();
	CTreeView::OnDestroy();
}


/////////////////////////////////////////////////////////////////////////////
// CTRegistryExplorerView diagnostics

#ifdef _DEBUG
void CTRegistryExplorerView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CTRegistryExplorerView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTRegistryExplorerView message handlers

void CTRegistryExplorerView::OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	services.OnItemexpanding( GetTreeCtrl(), pNMHDR, pResult);	
	*pResult = 0;
}
void CTRegistryExplorerView::OnSelchanging(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	services.OnSelchanging( GetTreeCtrl(), pNMHDR,  pResult);
	*pResult = 0;
}
void CTRegistryExplorerView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	services.OnSelchanged( GetTreeCtrl(), pNMHDR, pResult);
	*pResult = 0;
}

void CTRegistryExplorerView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (services.OnKeyDown( GetTreeCtrl(), nChar, nRepCnt, nFlags))
		return; //function returned TRUE

	CTreeView::OnKeyDown(nChar, nRepCnt, nFlags);
}

CString CTRegistryExplorerView::GetPath()
{
	CString strPath =  services.GetPath( GetTreeCtrl());
	return strPath;
}
BOOL CTRegistryExplorerView::SetPath( LPCTSTR lpszPath)
{
	return services.SetPath( GetTreeCtrl(), lpszPath);
}


